<template>
  <item-grid class="-my-4">
    <template v-for="item in cardItems">
      <media-object-card
        :key="item.id"
        v-bind="item"
        class="max-w-lg lg:max-w-sm lg:mx-4"
        :class="[{ 'my-4': item.id > 0 }]"
      />
    </template>
  </item-grid>
</template>

<script>
import MediaObjectCard from './MediaObjectCard';

export default {
  name: 'MediaObjectCardGrid',
  components: {
    MediaObjectCard,
  },
  props: {
    items: { type: Array, default: () => [] },
  },
  computed: {
    indexedItems() {
      return this.items.map((item, index) => ({
        id: index + 1,
        ...item,
      }));
    },
    cardItems() {
      const maxColumns = 3;
      const modulo = this.indexedItems.length % maxColumns;

      if (modulo != 0) {
        const emptyCards = this.buildEmptyCards(maxColumns - modulo);
        return [...this.indexedItems, ...emptyCards];
      }

      return this.indexedItems;
    },
  },
  methods: {
    buildEmptyCards(length) {
      return Array.from({ length }, (_, i) => -1 * (i + 1)).map(i => ({
        id: i,
        cardImage: null,
        cardContent: null,
      }));
    },
  },
};
</script>
